package ninja

import (
	"bufio"
	"fmt"
	"gonani/collections"
	"gonani/config/runtime_config"
	"gonani/defs"
	"gonani/rule"
	"gonani/target"
	"io"
	"os"
	"path"
	"strings"
)

type Writer struct {
	outputDir string
	writer    *bufio.Writer
	file      *os.File
}

var writtenNinjaRules []string
var writtenNinjaBuildTargets []string

var prefixedLines = []string{
	Variable("ninja_required_version", "1.10"),
}

func (w Writer) Close() error {
	w.writeFinalLines()

	_ = w.writer.Flush()
	return w.file.Close()
}

func NewWriter(outputDir string) Writer {
	if err := os.MkdirAll(outputDir, 0750); err != nil {
		panic(err)
	}
	file, err := os.OpenFile(path.Join(outputDir, "build.ninja"), os.O_WRONLY|os.O_CREATE|os.O_TRUNC, 0640)
	if err != nil {
		panic(err)
	}
	writer := Writer{
		outputDir: outputDir,
		writer:    bufio.NewWriterSize(file, 128),
		file:      file,
	}
	prefixedLines = append(prefixedLines, fmt.Sprintf("builddir = %s", runtime_config.RelOutputDir()))
	writer.writePrefixedLines()
	return writer
}

func ruleName(t target.Target, r rule.Rule, buildStepIndex int) string {
	extras := t.BuildRuleNameExtras()
	if len(extras) > 0 {
		extras = "." + extras
	}
	return fmt.Sprintf("target-rule.%s.%s.%s%s_%d", r.Type, r.Identifier, r.BuildFor, extras, buildStepIndex)
}

func hasWrittenRule(name string) bool {
	for _, writtenRuleName := range writtenNinjaRules {
		if writtenRuleName == name {
			return true
		}
	}
	return false
}

func (w Writer) WriteRule(t target.Target, r rule.Rule, c target.CommandBuildStep, buildStepIndex int) {
	ruleName := ruleName(t, r, buildStepIndex)
	if !hasWrittenRule(ruleName) {
		w.writeComment("rule %s, type %s, device %s", ruleName, r.Type, runtime_config.DeviceName())
		w.writeLine(RuleHeader(ruleName))
		if len(c.Description()) > 0 {
			w.writeLine(RuleDescription(c.Description()))
		}
		if len(c.DepFile()) > 0 {
			w.writeLine(RuleDepFile(c.DepFile()))
		} else if c.UseDeps() {
			w.writeLine(RuleDeps())
		}
		w.writeLine(Command(target.CommandBuildStepString(c, &r)))
	}
	w.writeNewLine()
}

func (w Writer) WriteTargetBuildRules(t target.Target) {
	w.writeNewLine()
	w.writeComment("%s (%s) %s", t.Rule().Identifier, t.Rule().BuildFor, t.Description())
	r := t.Rule()
	outputDir := t.Rule().OverwriteOutDir
	if len(outputDir) == 0 {
		outputDir = t.Rule().OutputDirFromProjectDir()
	}
	stringifier := Stringifier{OutputDir: outputDir}
	buildTargets := t.BuildSteps()
	index := 0
	var includedTargets []target.OutputFile
	collections.IterSorted(buildTargets, func(outputFileI interface{}, buildStepI interface{}) {
		outputFile := outputFileI.(string)
		buildStep := buildStepI.(target.CommandBuildStep)

		w.WriteRule(t, *r, buildStep, index)
		ruleName := ruleName(t, *r, index)

		var dependencies []string
		for _, dependency := range r.DependsOn {
			if strings.HasPrefix(dependency, defs.FileDependencyPrefix) {
				dependencies = append(dependencies, strings.TrimPrefix(dependency, defs.FileDependencyPrefix))
			} else {
				dependencies = append(dependencies, BuildOutputFromIdentifier(dependency))
			}
		}

		w.writeLine(
			stringifier.BuildTargetRule(
				outputFile,
				ruleName,
				target.BuildStepRelInputFiles(r, buildStep),
				dependencies...,
			),
		)

		includedTargets = append(includedTargets, stringifier.ConstructOutputDir(outputFile))

		w.writeNewLine()
		index++
	})

	for _, subTarget := range t.SubTargets() {
		w.WriteTargetBuildRules(subTarget)
		includedTargets = append(includedTargets, BuildOutputFromIdentifier(subTarget.Rule().Identifier))
	}

	phonyTarget := BuildOutputFromIdentifier(r.Identifier)
	w.writeLine(PhonyDependencyTarget(
		phonyTarget,
		includedTargets...,
	))

	writtenNinjaBuildTargets = append(writtenNinjaBuildTargets, phonyTarget)

	w.writeComment("End of %s (%s)", t.Rule().Identifier, t.Rule().BuildFor)
	w.writeNewLine()
}

func (w Writer) writePrefixedLines() {
	w.writeComment("Generated by gonani")
	w.writeComment("")
	w.writeComment("Project directory: %s", runtime_config.ProjectDir())
	w.writeComment("Output directory: %s", w.outputDir)
	w.writeComment("")
	w.writeComment("Device: %s", runtime_config.DeviceName())
	w.writeComment("")
	w.writeNewLine()
	w.writeLines(prefixedLines)
	w.writeNewLine()
}

func (w Writer) writeLine(line string) {
	_, err := io.WriteString(w.writer, line+"\n")
	if err != nil {
		panic(err)
	}
}

func (w Writer) writeLines(lines []string) {
	for _, line := range lines {
		w.writeLine(line)
	}
}

func (w Writer) writeNewLine() {
	w.writeLine("")
}

func (w Writer) writeComment(format string, a ...interface{}) {
	w.writeLine(Comment(format, a...))
}

func (w Writer) writeFinalLines() {
	w.writeLine(PhonyDependencyTarget("all", writtenNinjaBuildTargets...))
	w.writeLine(PhonyDependencyTarget("project",
		BuildOutputsFromIdentifiers(
			append(
				runtime_config.Config.ProjectConfig().Targets(),
				runtime_config.Config.DeviceConfig().Targets...,
			),
		)...))
	w.writeNewLine()
	w.writeComment("end of rules generated by gonani")
}

var _ io.Closer = (*Writer)(nil)
